/* Machine-dependent pthreads configuration and inline functions.
   ARM version.
   Copyright (C) 1997, 1998 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   Contributed by Philip Blundell <philb@gnu.org>.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <asm/asm.h>

#ifndef PT_EI
# define PT_EI extern inline
#endif


/* Spinlock implementation; required.  */
PT_EI int
testandset (int *spinlock)
{
  register unsigned int ret;

#if 0
/* XXX hack alert whack tyhis into shape ... */
        unsigned long oldval;
        unsigned long *v = (unsigned long *) ptr;

        __asm__ __volatile__("
1:      L       %0,%2;
        CS      %0,%1,%2;
        BNE     1b"
        : "+r" (oldval), "+r" (newval), "+m" (*v)
        :
        : "memory");

        return (void *) oldval;
#endif

  return ret;
}


/* Get some notion of the current stack.  Need not be exactly the top
   of the stack, just something somewhere in the current frame.  */
#define CURRENT_STACK_FRAME  stack_pointer
register char * stack_pointer __asm__ ("13");


/* Compare-and-swap for semaphores. */

#define HAS_COMPARE_AND_SWAP
PT_EI int
__compare_and_swap (volatile long int *p, long int oldval, long int newval)
{
  long int ret=0;

/* XXX figure out exactly what this is expected to do ... */
/* XXX figure out what the deired return code should be ... */
  __asm__ __volatile__ ("
        CS      %0,%1,%2;
        "
        : "+r" (oldval), "+r" (newval), "+m" (*p)
        : 
        : "memory");

  return ret;
}
